{
        Software realizzato da Sammarco Francesco a scopo didattico
        Mail: francesco.sammarco@gmail.com
}


unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Spin;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Chk_Min: TCheckBox;
    Chk_Mai: TCheckBox;
    Chk_Num: TCheckBox;
    Label1: TLabel;
    ListBox1: TListBox;
    Txt_QuantiCaratteri: TSpinEdit;
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BruteForce(Testo:string; Size: integer);
    procedure addme(testo:string);
    procedure setup(Size: integer);
    function checkme(Size: integer):boolean;
  private
    { private declarations }
  public
    { public declarations }
  end; 

const
  MAX_BRUTE : integer = 7;
  LOW_ALPHA : string  = 'abcdefghijklmnopqrstuvwxyz';
  UPR_ALPHA : string  = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
  STD_NUMBR : string  = '0123456789';

var
  Form1: TForm1;
  linke,confirm:array[0..7] of integer;
  len:integer;
  starttime,endtime:cardinal;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
   size: integer;
   caratteri: string;
begin
     ListBox1.Clear;
     caratteri:='';
     if Chk_Min.Checked=TRUE then
        caratteri:=caratteri+LOW_ALPHA;
     if Chk_Mai.Checked=TRUE then
        caratteri:=caratteri+UPR_ALPHA;
     if Chk_Num.Checked=TRUE then
        caratteri:=caratteri+STD_NUMBR;

     Size:=Txt_QuantiCaratteri.Value-1;
     BruteForce(Caratteri, Size);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
     Txt_QuantiCaratteri.MinValue:=1;
     Txt_QuantiCaratteri.MaxValue:=4;
end;

function TForm1.checkme(Size: integer):boolean;
var a,c:integer;
begin
c:=0;
  for a := MAX_BRUTE downto (MAX_BRUTE-size) do begin
    if confirm[a]=1 then begin
       if linke[a]>=len then c:=c+1;
    end;
  end;
  if c=size+1 then result:=true else result:=false;
end;

procedure TForm1.setup(Size: integer);
var a,b:integer;
begin
  b:=size;
  for a := MAX_BRUTE downto 0 do begin
    if b>-1 then begin
     confirm[a]:=1;
     b:=b-1;
    end else begin
     confirm[a]:=0;
    end;
  end;
end;

procedure TForm1.addme(testo:string);
begin
     ListBox1.Items.add(testo);
end;

procedure TForm1.BruteForce(Testo:string; Size: integer);
var
   a,b:integer;
   tmp:string;
begin
     len:=length(Testo)-1;
     for a := 0 to MAX_BRUTE do linke[a]:=-1;
         a:=-1;
     setup(Size);
     while not(checkme(Size)) do
     begin
           if not(a<len) then
           begin
              linke[MAX_BRUTE-1]:=linke[MAX_BRUTE-1]+1;
              for b := MAX_BRUTE-1 downto 1 do
              begin
                  if (linke[b]>len) then
                  begin
                     linke[b]:=0;
                     linke[b-1]:=linke[b-1]+1;
                  end;
              end;
              a:=-1;
           end;
           a:=a+1;
           tmp:='';
           for b := 0 to MAX_BRUTE-1 do
           begin
                if linke[b]>-1 then
                   tmp:=tmp+copy(Testo,linke[b]+1,1);
           end;
           if a<=len then
           begin
                linke[MAX_BRUTE]:=a;
                tmp:=tmp+copy(Testo,linke[MAX_BRUTE]+1,1);
           end;
           addme(tmp);
           ListBox1.Selected[ListBox1.count-1]:=true;
           ListBox1.Selected[listbox1.count-1]:=False;
           listbox1.refresh;
     end;
end;

end.

